using System;
using System.ComponentModel.Design;
using System.Reflection;
using System.Windows.Forms;

namespace FenixOPCBarGraph
{
	internal class BarCollectionEditor : CollectionEditor
	{
	    private CollectionForm form;
		
		public BarCollectionEditor(Type type) : base(type) {}
	        
	    protected override CollectionForm CreateCollectionForm()
        {
            form = base.CreateCollectionForm();

            Type formType = form.GetType();
            
            // Customize Property Browser
            FieldInfo propBrowser = formType.GetField("propertyBrowser", BindingFlags.NonPublic | BindingFlags.Instance);
            if (propBrowser != null)
            {
                PropertyGrid propGrid = (PropertyGrid)propBrowser.GetValue(form);
                
                if (propGrid != null)
                {
                    propGrid.ToolbarVisible = false;
                	propGrid.HelpVisible = true;
                }
            }

            return form;
        }
	}
}
