using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using System.ComponentModel;
using System.Windows.Forms.Design;
using System.Windows.Forms;

namespace FenixOPCBarGraph
{
    internal class DataLoggingEditor : UITypeEditor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            if (context != null) return UITypeEditorEditStyle.Modal;
            return base.GetEditStyle(context);
        }

        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            if ((context != null) && (provider != null))
            {
                IWindowsFormsEditorService editorService = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                if (editorService != null)
                {
                    DataLoggingEditorForm uxDataLoggingEditor = new DataLoggingEditorForm();

                    uxDataLoggingEditor.loggingConfig = (DataLoggingConfig)value;

                    if (editorService.ShowDialog(uxDataLoggingEditor) == DialogResult.OK)
                    {
                        return uxDataLoggingEditor.loggingConfig;
                    }
                }
            }
            return base.EditValue(context, provider, value);
        }
    }
}
