using System;
using System.Collections.Generic;
using System.Drawing.Design;
using System.ComponentModel.Design;
using System.Text;
using System.ComponentModel;
using System.Windows.Forms.Design;
using System.Windows.Forms;

namespace FenixOPCBarGraph
{
    internal class OPCTagEditor : UITypeEditor
    {
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            if (context != null) return UITypeEditorEditStyle.Modal;
            return base.GetEditStyle(context);
        }

        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            if ((context != null) && (provider != null))
            {
                IWindowsFormsEditorService editorService = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

                if (editorService != null)
                {
                    OPCTagEditorForm uxOPCEditor = new OPCTagEditorForm();

                    uxOPCEditor.tagConfig = (OPCTagConfig)value;

                    if( editorService.ShowDialog(uxOPCEditor) == DialogResult.OK ) 
                    {
                        return uxOPCEditor.tagConfig;
                    }
                }
            }
            return base.EditValue(context, provider, value);
        }
    }
}

