using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Globalization;

namespace FenixOPCBarGraph
{
    internal class RefreshIntervalConverter : TypeConverter
    {
        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            if (sourceType == typeof(string)) { return true; }
            return base.CanConvertFrom(context, sourceType);
        }

        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo info, object value)
        {
            if (value is string)
            {
                try
                {
                    string inputStr = (string)value;
                    string[] elements = inputStr.Trim().Split(' ');

                    if (elements.GetLength(0) <= 2)
                    {
                        return (Int32)(Double.Parse(elements[0]));
                    }
                }
                catch { }
                throw new ArgumentException("The arguments were not valid.");
            }
            return base.ConvertFrom(context, info, value);
        }

        public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
        {
            if (value is Int32)
            {
                if ((destinationType == typeof(string)))
                {
                    return string.Format("{0} {1}", value.ToString(), "ms");
                }
            }
            return base.ConvertTo(context, culture, value, destinationType);
        }
    }
}
